## eliom 4.0.0

=== Makefile ===
include Makefile.config

### Building

.PHONY: all byte opt doc

all:
	${MAKE} -C src all

byte:
	${MAKE} -C src byte

opt:
	${MAKE} -C src opt

odoc:
	$(MAKE) -C src odoc

doc:
	$(MAKE) -C doc doc

### Testing ###

.PHONY: run.local run.opt.local top links

run.local: tests.byte fifo
	ocsigenserver -c local/etc/${PROJECTNAME}.conf

tests.byte: byte links
	${MAKE} -C tests byte

run.opt.local: tests.opt fifo
	ocsigenserver.opt -c local/etc/${PROJECTNAME}.conf

tests.opt: opt links
	${MAKE} -C tests opt

links:
	-mkdir -p local/var/run
	-mkdir -p local/var/log
	-mkdir -p local/var/lib
	-mkdir -p local/lib/server
	-mkdir -p local/lib/client
	cd local/lib ; \
        ln -sf ../../src/syntax .  ; \
	cd server ; \
	ln -sf ../../../src/server/*cmi . ; \
	ln -sf ../../../src/clientserver/_server/*cmi . ; \
	ln -sf ../../../src/server2/*cmi . ; \
	ln -sf ../../../src/server2/extensions/*cmi . ; \
	ln -sf ../../../src/server2/eliom.cm* . ; \
	cd ../client ; \
	ln -sf ../../../src/client/*cmi . ; \
	ln -sf ../../../src/clientserver/_client/*cmi . ; \
	ln -sf ../../../src/client2/*cmi . ; \
	ln -sf ../../../src/client2/eliom_client.cma . ; \
	ln -sf ../../../src/client2/eliom_client_main.cmo .  ; \
	ln -sf ../../../src/client2/eliom_client.js .  ; \
	cd ../../..

fifo:
	[ -p local/var/run/${PROJECTNAME}_command ] || \
	 { mkfifo local/var/run/${PROJECTNAME}_command; \
	   chmod 660 local/var/run/${PROJECTNAME}_command; }


### Cleaning ###

clean: clean.local
	${MAKE} -C src clean
	${MAKE} -C tests clean

clean.local:
	-rm -f $(PROJECTNAME)-*.tar.gz

distclean: clean.local
	${MAKE} -C tests distclean
	-${MAKE} -C doc clean
	${MAKE} -C src distclean
	-rm Makefile.config
	-rm -f *~ \#* .\#*

### Installation ####

.PHONY: install uninstall reinstall

install:
	$(MAKE) -C src install
	@echo
	@echo "## Run \"make doc\" and \"make install.doc\" to build and install the ocamldoc."
install.byte:
	$(MAKE) -C src install.byte
install.opt:
	$(MAKE) -C src install.opt

uninstall:
	-$(MAKE) -C src uninstall

reinstall:
	$(MAKE) -C src reinstall
reinstall.byte:
	$(MAKE) -C src reinstall.byte
reinstall.opt:
	$(MAKE) -C src reinstall.opt

install.doc:
	${MAKE} -C doc install

###

.PHONY: dist

VERSION := $(shell head -n 1 VERSION)
dist:
	DARCS_REPO=$(PWD) darcs dist -d $(PROJECTNAME)-$(VERSION)

###

.PHONY: depend
depend:
	${MAKE} -C src syntax.depend
	${MAKE} -C src/syntax
	${MAKE} -C src tools.depend
	${MAKE} -C src/tools
	${MAKE} -C src files/META.${PROJECTNAME}
	${MAKE} -C src server.depend client.depend
	${MAKE} -C tests depend

=== doc/Makefile ===

doc: server.doc client.doc ocamlbuild.doc
server.doc:
	${MAKE} -C server doc
client.doc:
	${MAKE} -C client doc
ocamlbuild.doc:
	${MAKE} -C ocamlbuild doc

clean:
	${MAKE} -C server clean
	${MAKE} -C client clean
	${MAKE} -C ocamlbuild $@
	-rm -f *~ \#* .\#*

install:
	${MAKE} -C server install
	${MAKE} -C client install
	${MAKE} -C ocamlbuild $@

=== src/Makefile ===
include ../Makefile.config

all: metas conf
	${MAKE} -C syntax all
	${MAKE} -C server all
	${MAKE} -C client all
	${MAKE} -C tools all
	${MAKE} -C clientserver all
	${MAKE} -C server2 all
	${MAKE} -C client2 all
	${MAKE} -C ocamlbuild $@

byte: metas conf
	${MAKE} -C syntax all
	${MAKE} -C server byte
	${MAKE} -C client all
	${MAKE} -C tools all
	${MAKE} -C clientserver all
	${MAKE} -C server2 byte
	${MAKE} -C client2 all
	${MAKE} -C ocamlbuild $@

opt: metas conf
	${MAKE} -C syntax all
	${MAKE} -C server opt
	${MAKE} -C client all
	${MAKE} -C tools all
	${MAKE} -C clientserver opt
	${MAKE} -C server2 opt
	${MAKE} -C client2 all
	${MAKE} -C ocamlbuild $@

odoc:
	${MAKE} -C server odoc DEPEND=no
	${MAKE} -C client odoc DEPEND=no

clean:
	${MAKE} -C server clean DEPEND=no
	${MAKE} -C client clean DEPEND=no
	${MAKE} -C clientserver clean DEPEND=no
	${MAKE} -C server2 clean DEPEND=no
	${MAKE} -C client2 clean DEPEND=no
	${MAKE} -C tools clean
	${MAKE} -C syntax clean
	${MAKE} -C ocamlbuild $@
	-rm -f files/META  files/META.${PROJECTNAME}
	-rm -f ../local/etc/$(PROJECTNAME).conf

distclean:
	${MAKE} -C server distclean DEPEND=no
	${MAKE} -C client distclean DEPEND=no
	${MAKE} -C clientserver distclean DEPEND=no
	${MAKE} -C server2 distclean DEPEND=no
	${MAKE} -C client2 distclean DEPEND=no
	${MAKE} -C tools distclean
	${MAKE} -C syntax distclean
	${MAKE} -C ocamlbuild $@
	-rm -f *~ \#* .\#*

depend:
	${MAKE} syntax.depend
	${MAKE} tools.depend
	${MAKE} server.depend client.depend
syntax.depend:
	find syntax -name .\*.deps -delete
	${MAKE} -C syntax depend
	${MAKE} -C syntax pa_include.cmo
server.depend: syntax.depend
	find server -name .\*.deps -delete
	rm -f server/.depend
	find clientserver -name .\*.deps -delete
	rm -f clientserver/.depend
	find server2 -name .\*.deps -delete
	rm -f server2/.depend
	 ${MAKE} -C server .depend
	 ${MAKE} -C clientserver .depend
	 ${MAKE} -C server2 .depend
client.depend: syntax.depend
	find client -name .\*.deps -delete
	rm -f client/.depend
	find client2 -name .\*.deps -delete
	rm -f client2/.depend
	${MAKE} -C client .depend
	${MAKE} -C client2 .depend
tools.depend: syntax.depend
	find tools -name .\*.deps -delete
	${MAKE} -C tools depend

VERSION := $(shell head -n 1 ../VERSION)

install: install.META install.man
	${MAKE} -C clientserver install
	${MAKE} -C server install
	${MAKE} -C client install
	${MAKE} -C server2 install
	${MAKE} -C client2 install
	${MAKE} -C syntax install
	${MAKE} -C tools install
	${MAKE} -C ocamlbuild $@

install.man: install.META
	$(INSTALL) -m 755 -d $(TEMPROOT)$(MANDIR)/man1
	$(INSTALL) -m 755 files/eliomc.1 $(TEMPROOT)$(MANDIR)/man1
	$(INSTALL) -m 755 files/eliom-distillery.1 $(TEMPROOT)$(MANDIR)/man1
	ln -sf eliomc.1 $(TEMPROOT)$(MANDIR)/man1/js_of_eliom.1
	ln -sf eliomc.1 $(TEMPROOT)$(MANDIR)/man1/eliomopt.1
	ln -sf eliomc.1 $(TEMPROOT)$(MANDIR)/man1/eliomcp.1
	ln -sf eliomc.1 $(TEMPROOT)$(MANDIR)/man1/eliomdep.1

install.META:
	${OCAMLFIND} install ${PROJECTNAME} \
	   -destdir $(TEMPROOT)${LIBDIR} \
	   -patch-version ${VERSION} \
	   files/META

install.byte: install.META install.man
	${MAKE} -C clientserver install.byte
	${MAKE} -C server install.byte
	${MAKE} -C client2 install
	${MAKE} -C server2 install.byte
	${MAKE} -C client install
	${MAKE} -C syntax install
	${MAKE} -C tools install
	${MAKE} -C ocamlbuild $@

install.opt: install.META install.man
	${MAKE} -C clientserver install
	${MAKE} -C server install.opt
	${MAKE} -C client install
	${MAKE} -C server2 install.opt
	${MAKE} -C client2 install
	${MAKE} -C syntax install
	${MAKE} -C tools install
	${MAKE} -C ocamlbuild $@

uninstall:
	${MAKE} -C clientserver uninstall
	${MAKE} -C server uninstall
	${MAKE} -C client uninstall
	${MAKE} -C server2 uninstall
	${MAKE} -C client2 uninstall
	${MAKE} -C syntax uninstall
	${MAKE} -C tools uninstall
	${MAKE} -C ocamlbuild $@
	${OCAMLFIND} remove ${PROJECTNAME} \
	   -destdir $(TEMPROOT)${LIBDIR}
	rm -f $(TEMPROOT)$(MANDIR)/man1/eliomc.1
	rm -f $(TEMPROOT)$(MANDIR)/man1/js_of_eliom.1
	rm -f $(TEMPROOT)$(MANDIR)/man1/eliomopt.1
	rm -f $(TEMPROOT)$(MANDIR)/man1/eliomcp.1
	rm -f $(TEMPROOT)$(MANDIR)/man1/eliomdep.1
	rm -f $(TEMPROOT)$(MANDIR)/man1/eliom-distillery.1

reinstall: uninstall install
reinstall.byte: uninstall install.byte
reinstall.opt: uninstall install.opt

metas: files/META files/META.${PROJECTNAME}

SED_META := -e s/%%NAME%%/$(PROJECTNAME)/g \
	    -e s/%%DEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${SERVER_PACKAGE})/g \
	    -e s/%%CDEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${CLIENT_PACKAGE})/g \
	    -e s/%%SDEPS%%/$(shell ${OCAMLFIND} query -p-format -separator ',' ${EXTRA_SYNTAXES})/g \

files/META: files/META.in ../Makefile.config  ../Makefile.options Makefile
	sed ${SED_META} $< > $@

files/META.${PROJECTNAME}: files/META.in ../Makefile.config  ../Makefile.options Makefile
	echo "directory = \"../../local/lib\"" > $@
	sed ${SED_META} $< >> $@

conf: ../local/etc/$(PROJECTNAME).conf

CONF_SED := -e s%_LOGDIR_%$(SRC)/local/var/log%g
CONF_SED += -e s%_DATADIR_%$(SRC)/local/var/lib%g
CONF_SED += -e s%\<user\>_OCSIGENUSER_\</user\>%%g
CONF_SED += -e s%\<group\>_OCSIGENGROUP_\</group\>%\<debugmode/\>%g
CONF_SED += -e s%_COMMANDPIPE_%$(SRC)/local/var/run/${PROJECTNAME}_command%g
CONF_SED += -e s%_MIMEFILE_%$(SRC)/src/files/mime.types%g
CONF_SED += -e "s%_METADIR_%$(addsuffix \"/\>\<findlib path=\",$(shell ocamlfind printconf path))$(SRC)/src/files/%g" -e s%path=\"\ %path=\"%g
CONF_SED += -e s%_OCSDIR_%$(shell ${OCAMLFIND} query ocsigenserver)%g
CONF_SED += -e s%_OCSEXTDIR_%$(shell ${OCAMLFIND} query ocsigenserver.ext)%g
CONF_SED += -e s%_PROJECTNAME_%$(PROJECTNAME)%g
CONF_SED += -e s%_CONFIGDIR_%$(SRC)/local/etc%g
CONF_SED += -e s%_STATICPAGESDIR_%$(SRC)/local/var/www%g
CONF_SED += -e s%_LOCALDIR_%$(SRC)/local%g
CONF_SED += -e s%store\ dir=\"$(SRC)/var/lib\"%store\ dir=\"$(SRC)/local/var/lib/ocsipersist\"%g

../local/etc/$(PROJECTNAME).conf: files/${PROJECTNAME}.conf.in ../Makefile.config Makefile
	mkdir -p ../local/etc
	cat $< | sed ${CONF_SED}  > $@

=== tests/Makefile ===
include ../Makefile.config

## Use local files
## (tests do not require global installation of Eliom)
export OCAMLPATH := ${SRC}/src/files:${OCAMLPATH}
export PATH := ${SRC}/src/tools:${PATH}
export ELIOM_DATA_DIR := ${SRC}/src/files

ifeq "${DEBUG}" "YES"
  DEBUG_OPTION := -g
else
  DEBUG_OPTION :=
endif

#BINPREFIX=../src/tools/
BINPREFIX=

ELIOMC   := ${BINPREFIX}eliomc ${DEBUG_OPTION} -package deriving.syntax.std
ELIOMOPT := ${BINPREFIX}eliomopt ${DEBUG_OPTION} -package deriving.syntax.std
ELIOMDEPS := ${BINPREFIX}eliomdep -server -package deriving.syntax.std
ELIOMDEPC := ${BINPREFIX}eliomdep -client -package deriving.syntax.std
JS_OF_ELIOM := ${BINPREFIX}js_of_eliom ${DEBUG_OPTION} -package deriving.syntax.std

ifeq "${NATDYNLINK}" "YES"
all: byte opt
else
all: byte
endif

#### Main site : eliom_testsuite ####

SERVER_PACKAGE :=
CLIENT_PACKAGE :=

SERVER_FILES := eliom_testsuite_base.eliom \
                eliom_testsuite1.ml \
                eliom_testsuite2.ml \
                eliom_testsuite3.eliom \
                eliom_testsuite4.eliom \
                eliom_testsuite5.eliom \
		eliom_testsuite.ml     \
                atom_example.ml \

CLIENT_FILES := eliom_testsuite_base.eliom \
                eliom_testsuite3.eliom \
                eliom_testsuite4.eliom \
                eliom_testsuite5.eliom

OTHER_FILES := eliom_testsuite_global.eliom eliom_testsuite_site.eliom

STATICDIR := ../local/var/www/tests
TYPE_DIR =

DISTILLERY_FILES := $(addprefix $(STATICDIR)/distillery/basic/,test.cma test.cmxa test.js)

byte:: _server/eliom_testsuite_global.cmo _server/eliom_testsuite_site.cmo eliom_testsuite.cma ${STATICDIR}/eliom_testsuite.js distillery-basic-byte
opt:: _server/eliom_testsuite_global.cmxs _server/eliom_testsuite_site.cmxs eliom_testsuite.cmxs ${STATICDIR}/eliom_testsuite.js distillery-basic-opt

#### Distillery ####

.PHONY: distillery-basic-byte distillery-basic-opt

distillery/basic:
	mkdir -p $@
	eliom-distillery -name distillery_basic -target-directory $@
	echo 'PREFIX=$(CURDIR)/../local/' >> $@/Makefile.options
	echo 'STATICDIR=var/www/distillery-basic/static' >> $@/Makefile.options
	echo 'ELIOMSTATICDIR=var/www/distillery-basic/eliomstatic' >> $@/Makefile.options
	echo 'LIBDIR=var/www/distillery-basic/lib' >> $@/Makefile.options
	echo 'WWWUSER=' >> $@/Makefile.options
	echo 'WWWGROUP=' >> $@/Makefile.options
	make -C $@ byte install.static
distillery-basic-byte: | distillery/basic
	make -C distillery/basic byte install.lib.byte
distillery-basic-opt: | distillery/basic
	make -C distillery/basic opt install.lib.opt

#### Server side #######

SERVER_INC  := ${addprefix -package ,${SERVER_PACKAGE}}

SERVER_OBJS := $(patsubst %.eliom,_server/%.cmo, \
	          $(patsubst %.ml,_server/%.cmo,${SERVER_FILES}))

eliom_testsuite.cma: ${SERVER_OBJS}
	${ELIOMC} -a -o $@ $^
eliom_testsuite.cmxa: ${SERVER_OBJS:.cmo=.cmx}
	${ELIOMOPT} -a -o $@ $^

${or ${TYPE_DIR},_server}/%.type_mli: %.eliom
	${ELIOMC} -infer ${SERVER_INC} -o $@ $<

_server/%.cmi: %.mli
	${ELIOMC} -c ${SERVER_INC} $<

_server/%.cmo: %.ml
	${ELIOMC} -c ${SERVER_INC} $<
_server/%.cmo: %.eliom _server/%.type_mli
	${ELIOMC} -c ${addprefix -type-dir ,${TYPE_DIR}} ${SERVER_INC} $<

_server/%.cmx: %.ml
	${ELIOMOPT} -c ${SERVER_INC} $<
_server/%.cmx: %.eliom
	${ELIOMOPT} -c ${addprefix -type-dir ,${TYPE_DIR}} ${SERVER_INC} $<

%.cmxs: %.cmxa
	$(ELIOMOPT) -shared -linkall -o $@ $<

%.cmxs: %.cmx
	$(ELIOMOPT) -shared -linkall -o $@ $<

##### Client side ####

CLIENT_LIBS := ${addprefix -package ,${CLIENT_PACKAGE}}
CLIENT_INC  := ${addprefix -package ,${CLIENT_PACKAGE}}

CLIENT_OBJS := $(patsubst %.eliom,_client/%.cmo, \
	          $(patsubst %.ml,_client/%.cmo,${CLIENT_FILES}))

${STATICDIR}/eliom_testsuite.js:  ${CLIENT_OBJS}
	${JS_OF_ELIOM} -o $@ -jsopt -pretty -jsopt -noinline ${CLIENT_LIBS} $^

_client/%.cmi: %.mli
	${JS_OF_ELIOM} -c ${CLIENT_INC} $<

_client/%.cmo: %.eliom
	${JS_OF_ELIOM} -c ${addprefix -type-dir ,${TYPE_DIR}} ${CLIENT_INC} $<
_client/%.cmo: %.ml
	${JS_OF_ELIOM} -c ${CLIENT_INC} $<

####### Aux site: miniwiki #######

byte:: miniwiki.byte
opt:: miniwiki.opt

miniwiki.byte:
	$(MAKE) --no-print-directory -C miniwiki byte

miniwiki.opt:
	$(MAKE) --no-print-directory -C miniwiki opt

############

## Clean up

clean: clean.local
	${MAKE} -C miniwiki clean
clean.local:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f ${or ${TYPE_DIR},_server}/*.type_mli
	-rm -f ${STATICDIR}/eliom_testsuite.js
	-rm -rf _client/* _server/*
	-rm -rf distillery

distclean: clean.local
	-rm -f *~ \#* .\#* .depend
	${MAKE} -C miniwiki distclean

## Dependencies

depend: .depend

.depend:
	${MAKE} -C miniwiki depend
	$(ELIOMDEPS) ${SERVER_INC} ${addprefix -type-dir ,${TYPE_DIR}} ${SERVER_FILES} ${OTHER_FILES} | sed s%_server//%/% > .depend
	$(ELIOMDEPC) ${CLIENT_INC} ${addprefix -type-dir ,${TYPE_DIR}} ${CLIENT_FILES} $(OTHER_FILES) >> .depend

include .depend

## TODO

# %.wiki: %.ml
# cat $< | sed '1,/(\*wiki\*/d' | sed '/%<||2>%/,$$ d' | /bin/sh ./tutomake.sh > $@

=== doc/client/Makefile ===
include ../../Makefile.config
include ../../src/client/Makefile.filelist
include ../../src/clientserver/Makefile.filelist
include ../../src/client2/Makefile.filelist

OCAMLDOC := ${OCAMLFIND} ocamldoc

ODOC := $(addprefix ../../src/client/,$(DOC:.mli=.odoc)) \
        $(addprefix ../../src/clientserver/,$(CCDOC:.mli=.odoc)) \
        $(addprefix ../../src/client2/,$(CCCDOC:.mli=.odoc))


doc: odoc api-html/index.html api-man/Eliom_lib.client.3o
wikidoc: odoc api-wiki/index.wiki

odoc:
	${MAKE} -C ../../src/client odoc

api-html/index.html: indexdoc ${ODOC}
	mkdir -p api-html
	$(OCAMLDOC) ${LIBS} -d api-html -intro indexdoc $(addprefix -load ,${ODOC}) -html

api-man/Eliom_lib.client.3o: ${ODOC}
	mkdir -p api-man
	$(OCAMLDOC) ${LIBS} -d api-man -man-mini $(addprefix -load ,${ODOC}) -man \
	  -man-section 3o -man-suffix client.3o

api-wiki/index.wiki: indexdoc ${ODOC}
	mkdir -p api-wiki
	ODOC_WIKI_SUBPROJECT=client $(OCAMLDOC) -d api-wiki -intro indexdoc \
	   -i $(shell ocamlfind query wikidoc) -g odoc_wiki.cma \
	   -colorize-code $(addprefix -load ,${ODOC})

install:
	${INSTALL} -d -m 755 $(TEMPROOT)$(DOCDIR)/client
	$(INSTALL) -m 644 api-html/* $(TEMPROOT)$(DOCDIR)/client
	$(INSTALL) -m 755 -d $(TEMPROOT)$(MANDIR)/man3
	$(INSTALL) -m 755 api-man/* $(TEMPROOT)$(MANDIR)/man3

clean:
	-rm -f ${ODOC}
	-rm -f api-html/*
	-rm -f api-man/*
	-rm -f api-wiki/*
	-rm -f *~ \#* .\#*
	-rm -rf ${TMP}

=== doc/ocamlbuild/Makefile ===
include ../../Makefile.config
include ../../src/ocamlbuild/Makefile.filelist

OCAMLDOC := ${OCAMLFIND} ocamldoc

ODOC := $(addprefix ../../src/ocamlbuild/_build/,$(DOC))

doc: odoc api-html/index.html
wikidoc: odoc api-wiki/index.wiki

odoc:
	${MAKE} -C ../../src/ocamlbuild odoc

api-html/index.html: indexdoc ${ODOC}
	mkdir -p api-html
	$(OCAMLDOC) ${LIBS} -d api-html -intro indexdoc $(addprefix -load ,${ODOC}) -html

api-wiki/index.wiki: indexdoc ${ODOC}
	mkdir -p api-wiki
	ODOC_WIKI_SUBPROJECT=ocamlbuild $(OCAMLDOC) -d api-wiki -intro indexdoc \
	   -i $(shell ocamlfind query wikidoc) -g odoc_wiki.cma \
	   -colorize-code $(addprefix -load ,${ODOC})

install:
	${INSTALL} -d -m 755 $(TEMPROOT)$(DOCDIR)/ocamlbuild
	$(INSTALL) -m 644 api-html/* $(TEMPROOT)$(DOCDIR)/ocamlbuild

clean:
	-rm -f api-html/*
	-rm -f api-wiki/*
	-rm -f *~ \#* .\#*

=== doc/server/Makefile ===
include ../../Makefile.config
include ../../src/server/Makefile.filelist
include ../../src/clientserver/Makefile.filelist
include ../../src/server2/Makefile.filelist

OCAMLDOC := ${OCAMLFIND} ocamldoc

ODOC := $(addprefix ../../src/server/,$(SDOC:.mli=.odoc)) \
        $(addprefix ../../src/clientserver/,$(SSDOC:.mli=.odoc)) \
        $(addprefix ../../src/server2/,$(SSSDOC:.mli=.odoc))

INCLUDEDOC := -I ../../src/server/ \
              -I ../../src/clientserver/_server \
              -I ../../src/server2/

doc: odoc api-html/index.html api-man/Eliom_lib.server.3o
wikidoc: odoc api-wiki/index.wiki

odoc:
	${MAKE} -C ../../src/server odoc

api-html/index.html: indexdoc ${ODOC}
	mkdir -p api-html
	$(OCAMLDOC) ${LIBS} ${INCLUDEDOC} -d api-html -intro indexdoc $(addprefix -load ,${ODOC}) -html

api-man/Eliom_lib.server.3o: ${ODOC}
	mkdir -p api-man
	$(OCAMLDOC) ${LIBS} -d api-man -man-mini $(addprefix -load ,${ODOC}) -man \
	  -man-section 3o -man-suffix server.3o

api-wiki/index.wiki: indexdoc ${ODOC}
	mkdir -p api-wiki
	ODOC_WIKI_SUBPROJECT=server $(OCAMLDOC) -d api-wiki -intro indexdoc \
	   -i $(shell ocamlfind query wikidoc) -g odoc_wiki.cma \
	   -colorize-code $(addprefix -load ,${ODOC})

install:
	${INSTALL} -d -m 755 $(TEMPROOT)$(DOCDIR)/server
	$(INSTALL) -m 644 api-html/* $(TEMPROOT)$(DOCDIR)/server
	$(INSTALL) -m 755 -d $(TEMPROOT)$(MANDIR)/man3
	$(INSTALL) -m 755 api-man/* $(TEMPROOT)$(MANDIR)/man3

clean:
	-rm -f ${ODOC}
	-rm -f api-html/*
	-rm -f api-man/*
	-rm -f api-wiki/*
	-rm -f *~ \#* .\#*

=== src/client/Makefile ===
include ../../Makefile.config
include Makefile.filelist
include ../clientserver/Makefile.filelist
include ../client2/Makefile.filelist

LIBS     := -I private ${addprefix -package ,${CLIENT_PACKAGE} ${EXTRA_SYNTAXES} deriving.syntax.std} \
	    -ppopt ../syntax/pa_include.cmo

OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep
OCAMLDOC := ${OCAMLFIND} ocamldoc -ppopt o -ppopt -printer

INCLUDEDOC := -I ../client2 -I ../clientserver/_client -I .

### Common files ###

COMMON_FILES  := $(notdir $(wildcard ../common/*.mli) $(wildcard ../common/*.ml))
COMMON_PFILES := $(addprefix private/, \
		     $(notdir $(wildcard ../common/private/*.mli) \
	                      $(wildcard ../common/private/*.ml)))
COMMON_SFILES := $(addprefix sigs/, \
		     $(notdir $(wildcard ../common/sigs/*.mli) \
	                      $(wildcard ../common/sigs/*.ml)))

PREDEP := ${COMMON_FILES} ${COMMON_PFILES} ${COMMON_SFILES}


### Library ###

FILES := ${CFILES}

CINTF_NOP4 :=


##########

all: ${FILES:.ml=.cmo}


.SECONDARY: ${PREDEP}
${COMMON_FILES}: %: ../common/%
	-@mkdir -p $(dir $@)
	ln -s $< $@
${COMMON_PFILES} ${COMMON_SFILES}: %: ../common/%
	-@mkdir -p $(dir $@)
	ln -s ../$< $@

##########

%.cmo: %.ml
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) -syntax camlp4o ${LIBS} -c $<

%.cmi: %.mli
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
${CINTF_NOP4:.mli=.cmi}: \
%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<

%.odoc: %.mli
	${OCAMLDOC} -syntax camlp4o ${LIBS} ${INCLUDEDOC} -dump ${ODOC_DIR}$@ ${@:.odoc=.mli}

../clientserver/_client/%.odoc: ../clientserver/%.client.mli
	-cp -f $< ${@:.odoc=.mli}
	-ln -s ../sigs ../clientserver/_client
	-ln -s ../client ../clientserver/client
	${OCAMLDOC} -syntax camlp4o ${LIBS} ${INCLUDEDOC} -dump ${ODOC_DIR}$@ ${@:.odoc=.mli}
	-rm -f ${@:.odoc=.mli}

${CINTF_NOP4:.mli=.odoc}: \
%.odoc: %.mli
	${OCAMLDOC} ${LIBS} -dump ${ODOC_DIR}$@ $<

%.cmxs: %.cmx
	$(OCAMLOPT) -shared -linkall -o $@ $<
%.o: %.c
	$(OCAMLC) -c $<




## INSTALL ##


odoc: ${CDOC:.mli=.odoc} \
      $(addprefix ../clientserver/,${CCDOC:.mli=.odoc}) \
      $(addprefix ../client2/,${CCCDOC:.mli=.odoc})

install: ${PREDEP}
	${INSTALL} -m 755 -d ${CLIENTDIR}
	${INSTALL} -m 644 ${CINTF} ${CDOC} ${CLIENTDIR}

uninstall:
	-rm -fr ${CLIENTDIR}

#####

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot *.deps *.odoc *.so
	-cd private && rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot *.odoc

distclean: clean
	-rm -f *~ \#* .\#* .depend
	-rm -f ${PREDEP}
	-rm -f .*.deps private/.*.deps extensions/.*.deps

##  Manual dependencies for pa_include

eliom_registration.cmi eliom_registration.cmo eliom_registration.cmx eliom_registration.odoc \
eliom_mkforms.cmi eliom_mkforms.odoc: ${COMMON_SFILES} $(wildcard sigs/*.mli)

# Automatic dependencies

ifneq (${DEPEND},no)

## Ugly side effect to force ${PREDEP} creation before dependencies calculation
dummy_var := $(shell $(MAKE) DEPEND=no ${PREDEP} >/dev/null 2>&1)

DEPS := $(patsubst %,.%.deps,${COMMON_FILES}) \
	$(patsubst %,.%.deps,${COMMON_PFILES}) \
	$(patsubst %,.%.deps,$(wildcard *.mli *.ml)) \
        $(patsubst private/%,private/.%.deps,$(wildcard private/*.mli private/*.ml)) \

.SECONDARY: ${DEPS}
.depend: ${DEPS}
	cat $(shell ls .*.deps private/.*.deps) > .depend

.%.ml.deps: %.ml
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@
.%.mli.deps: %.mli
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@

private/.%.ml.deps: private/%.ml
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@
private/.%.mli.deps: private/%.mli
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@

$(patsubst %.mli,.%.mli.deps,${CINTF_NOP4}): .%.mli.deps: %.mli
	 ${OCAMLDEP} ${LIBS} $< > $@

include .depend

endif

=== src/client2/Makefile ===
include ../../Makefile.config
include ../client/Makefile.filelist

LIBS     := -I ../client -I ../client/private -I ../common -I ../common2 \
            -I ../clientserver/_client \
            ${addprefix -package ,${CLIENT_PACKAGE} ${EXTRA_SYNTAXES} deriving.syntax.std} \
	    -ppopt ../syntax/pa_include.cmo

OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep
OCAMLDOC := ${OCAMLFIND} ocamldoc -ppopt o -ppopt -printer

all: eliom_client.cma eliom_client_main.cmo

### Common files ###

COMMON_FILES  := $(notdir $(wildcard ../common2/*.mli) $(wildcard ../common2/*.ml))
COMMON_PFILES := $(addprefix private/, \
		     $(notdir $(wildcard ../common2/private/*.mli) \
	                      $(wildcard ../common2/private/*.ml)))
COMMON_SFILES := $(addprefix sigs/, \
		     $(notdir $(wildcard ../common2/sigs/*.mli) \
	                      $(wildcard ../common2/sigs/*.ml)))

PREDEP := ${COMMON_FILES} ${COMMON_PFILES} ${COMMON_SFILES}

.SECONDARY: ${PREDEP}
${COMMON_FILES}: %: ../common2/%
	-@mkdir -p $(dir $@)
	ln -s $< $@
${COMMON_PFILES} ${COMMON_SFILES}: %: ../common2/%
	-@mkdir -p $(dir $@)
	ln -s ../$< $@

### Library ###

CCFILES := $(addprefix ../client/, $(CFILES))

FILES := eliom_tools.ml \
	 eliom_comet_base.ml \
         eliom_comet.ml \
	 eliom_bus.ml \
	 eliom_react.ml

INTF_NOP4 :=

eliom_client.cma: ${CCFILES:.ml=.cmo} $(wildcard ../clientserver/_client/*.cmo) ${FILES:.ml=.cmo}
	${OCAMLC} -a -o $@ $^

##########

%.cmo: %.ml
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) -syntax camlp4o ${LIBS} -c $<

%.cmi: %.mli
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
${INTF_NOP4:.mli=.cmi}: \
%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<

%.odoc: %.mli
	${OCAMLDOC} -syntax camlp4o ${LIBS} -dump ${ODOC_DIR}$@ $<
${INTF_NOP4:.mli=.odoc}: \
%.odoc: %.mli
	${OCAMLDOC} ${LIBS} -dump ${ODOC_DIR}$@ $<

%.cmxs: %.cmx
	$(OCAMLOPT) -shared -linkall -o $@ $<
%.o: %.c
	$(OCAMLC) -c $<




## INSTALL ##

include Makefile.filelist

odoc: ${DOC:.mli=.odoc}

install: ${PREDEP}
	${INSTALL} -m 755 -d ${CLIENTDIR}
	${INSTALL} -m 644 ${INTF} ${IMPL} ${STUBS} ${DOC} ${CLIENTDIR}

uninstall:
	-rm -fr ${CLIENTDIR}

#####

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot *.deps *.odoc *.so
	-cd private && rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot *.odoc

distclean: clean
	-rm -f *~ \#* .\#* .depend
	-rm -f ${PREDEP}
	-rm -f .*.deps private/.*.deps extensions/.*.deps

##  Manual dependencies for pa_include

eliom_registration.cmi eliom_registration.cmo eliom_registration.cmx eliom_registration.odoc \
eliom_mkforms.cmi eliom_mkforms.odoc: ${COMMON_SFILES} $(wildcard sigs/*.mli)

# Automatic dependencies

ifneq (${DEPEND},no)

## Ugly side effect to force ${PREDEP} creation before dependencies calculation
dummy_var := $(shell $(MAKE) DEPEND=no ${PREDEP} >/dev/null 2>&1)

DEPS := $(patsubst %,.%.deps,${COMMON_FILES}) \
	$(patsubst %,.%.deps,${COMMON_PFILES}) \
	$(patsubst %,.%.deps,$(wildcard *.mli *.ml)) \
        $(patsubst private/%,private/.%.deps,$(wildcard private/*.mli private/*.ml)) \

.SECONDARY: ${DEPS}
.depend: ${DEPS}
	cat $(shell ls .*.deps private/.*.deps) > .depend

.%.ml.deps: %.ml
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@
.%.mli.deps: %.mli
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@

private/.%.ml.deps: private/%.ml
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@
private/.%.mli.deps: private/%.mli
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@

$(patsubst %.mli,.%.mli.deps,${INTF_NOP4}): .%.mli.deps: %.mli
	 ${OCAMLDEP} ${LIBS} $< > $@

include .depend

endif

=== src/clientserver/Makefile ===
include ../../Makefile.config
include ../server/Makefile.filelist
include ../client/Makefile.filelist

export OCAMLPATH := ${SRC}/src/files:${OCAMLPATH}
export PATH := ${SRC}/src/tools:${PATH}
export ELIOM_DATA_DIR := ${SRC}/src/files

##

# Source files for the server
SERVER_FILES := $(wildcard *.eliom)
# Source files for the client
CLIENT_FILES := $(wildcard *.eliom)

# OCamlfind packages for the server
SERVER_PACKAGES :=
# OCamlfind packages for the client
CLIENT_PACKAGES :=

##----------------------------------------------------------------------
##			      Internals

## Required binaries
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG}
OCAMLDOC := $(OCAMLFIND) ocamldoc
OCAMLDEP := $(OCAMLFIND) ocamldep
OCAMLDOC := ${OCAMLFIND} ocamldoc -ppopt o -ppopt -printer

ELIOMC            := ../tools/eliomc
ELIOMOPT          := ../tools/eliomopt
JS_OF_ELIOM       := ../tools/js_of_eliom
ELIOMDEP          := ../tools/eliomdep

## Where to put intermediate object files.
## - ELIOM_{SERVER,CLIENT}_DIR must be distinct
## - ELIOM_CLIENT_DIR must not be the local dir.
## - ELIOM_SERVER_DIR could be ".", but you need to
##   remove it from the "clean" rules...
export ELIOM_SERVER_DIR := _server
export ELIOM_CLIENT_DIR := _client
export ELIOM_TYPE_DIR   := _server
DEPSDIR := _deps

ifeq ($(DEBUG),yes)
  GENERATE_DEBUG ?= -g
  RUN_DEBUG ?= "-v"
  DEBUG_JS ?= -jsopt -pretty -jsopt -noinline -jsopt -debuginfo
endif

##----------------------------------------------------------------------
## Aux

# Use `eliomdep -sort' only in OCaml>4
ifeq ($(shell ocamlc -version|cut -c1),4)
eliomdep=$(shell $(ELIOMDEP) $(1) -sort $(2) $(filter %.eliom %.ml,$(3))))
else
eliomdep=$(3)
endif
objs=$(patsubst %.ml,$(1)/%.$(2),$(patsubst %.eliom,$(1)/%.$(2),$(filter %.eliom %.ml,$(3))))
depsort=$(call objs,$(1),$(2),$(call eliomdep,$(3),$(4),$(5)))


##----------------------------------------------------------------------
## General

INCLUDEDOC := -I ../server2 -I ../clientserver -I ../common -I ../common2

.PHONY: all byte opt
all: byte opt
byte: $(SERVER_FILES:.eliom=.eliomi) \
     $(call objs,$(ELIOM_SERVER_DIR),cmi,$(SERVER_FILES)) \
     $(call objs,$(ELIOM_CLIENT_DIR),cmi,$(CLIENT_FILES)) \
     $(call objs,$(ELIOM_SERVER_DIR),cmo,$(SERVER_FILES)) \
     $(call objs,$(ELIOM_CLIENT_DIR),cmo,$(CLIENT_FILES))
opt: byte $(call objs,$(ELIOM_SERVER_DIR),cmx,$(SERVER_FILES))


##----------------------------------------------------------------------
## Server side compilation

SERVER_INC  := -I ../server/ -I ../server/private \
               ${addprefix -package ,${SERVER_PACKAGES}} \
               -ppopt ../syntax/pa_include.cmo

${ELIOM_TYPE_DIR}/%.type_mli: %.eliom
	${ELIOMC} -infer ${SERVER_INC} $<

${ELIOM_SERVER_DIR}/%.cmi: %.mli
	${ELIOMC} -c ${SERVER_INC} $(GENERATE_DEBUG) $<

${ELIOM_SERVER_DIR}/%.cmi: %.eliomi
	${ELIOMC} -c ${SERVER_INC} $(GENERATE_DEBUG) $<

${ELIOM_SERVER_DIR}/%.cmo: %.ml
	${ELIOMC} -c ${SERVER_INC} $(GENERATE_DEBUG) $<
${ELIOM_SERVER_DIR}/%.cmo: %.eliom
	${ELIOMC} -c ${SERVER_INC} $(GENERATE_DEBUG) $<

${ELIOM_SERVER_DIR}/%.cmx: %.ml
	${ELIOMOPT} -c ${SERVER_INC} $(GENERATE_DEBUG) $<
${ELIOM_SERVER_DIR}/%.cmx: %.eliom ${ELIOM_SERVER_DIR}/%.cmi
	${ELIOMOPT} -c ${SERVER_INC} $(GENERATE_DEBUG) $<

%.cmxs: %.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $<

%.eliomi: %.server.mli %.client.mli
	echo "{client{" > $@
	cat $(@:.eliomi=.client.mli) >> $@
	echo "}}" >> $@
	echo "{server{" >> $@
	cat $(@:.eliomi=.server.mli) >> $@
	echo "}}" >> $@

##----------------------------------------------------------------------
## Client side compilation

CLIENT_INC  := -I ../client/ -I ../client/private \
	       ${addprefix -package ,${CLIENT_PACKAGES}} \
               -ppopt ../syntax/pa_include.cmo

${ELIOM_CLIENT_DIR}/%.cmi: %.mli
	${JS_OF_ELIOM} -c ${CLIENT_INC} $(GENERATE_DEBUG) $<

${ELIOM_CLIENT_DIR}/%.cmo: %.eliom %.eliomi ${ELIOM_CLIENT_DIR}/%.cmi
	${JS_OF_ELIOM} -c ${CLIENT_INC} $(GENERATE_DEBUG) $<
${ELIOM_CLIENT_DIR}/%.cmo: %.ml
	${JS_OF_ELIOM} -c ${CLIENT_INC} $(GENERATE_DEBUG) $<

${ELIOM_CLIENT_DIR}/%.cmi: %.eliomi
	${JS_OF_ELIOM} -c ${CLIENT_INC} $(GENERATE_DEBUG) $<



##----------------------------------------------------------------------
## Doc

# odoc: _server/eliom_content.odoc _client/eliom_content.odoc

# _server/%.odoc: %.server.mli
# 	${OCAMLDOC} -syntax camlp4o ${LIBS} ${INCLUDEDOC} -dump ${ODOC_DIR}$@ _server/$*.mli

# _client/%.odoc: %.client.mli
# 	${OCAMLDOC} -syntax camlp4o ${LIBS} ${INCLUDEDOC} -dump ${ODOC_DIR}$@ _client/$*.mli


##----------------------------------------------------------------------
## Install

odoc: ${DOC:.eliomi=.odoc}

INTF := $(wildcard *.eliomi)
MODULES := $(wildcard *.eliom)

install:
	${INSTALL} -m 755 -d ${SERVERDIR}
	${INSTALL} -m 644 ${INTF} $(addprefix _server/, ${MODULES:.eliom=.cmi}) ${SERVERDIR}
	${INSTALL} -m 755 -d ${CLIENTDIR}
	${INSTALL} -m 644 ${INTF} $(addprefix _client/, ${MODULES:.eliom=.cmi}) ${CLIENTDIR}

uninstall:



##----------------------------------------------------------------------
## Dependencies

include .depend

.depend: $(patsubst %,$(DEPSDIR)/%.server,$(SERVER_FILES)) $(patsubst %,$(DEPSDIR)/%.client,$(CLIENT_FILES))
	cat $^ > $@

$(DEPSDIR)/%.server: % | $(DEPSDIR)
	$(ELIOMDEP) -server $(SERVER_INC) $< > $@

$(DEPSDIR)/%.client: % | $(DEPSDIR)
	$(ELIOMDEP) -client $(CLIENT_INC) $< > $@

$(DEPSDIR):
	mkdir $@

_server/eliom_content.cmo: _server/eliom_content.cmi
_client/eliom_content.cmo: _client/eliom_content.cmi

##----------------------------------------------------------------------
## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot
	-rm -f *.type_mli
	-rm -f *.eliomi
	-rm -f ${PROJECT_NAME}.js
	-rm -rf ${ELIOM_CLIENT_DIR} ${ELIOM_SERVER_DIR}

distclean: clean
	-rm -rf $(TEST_PREFIX) $(DEPSDIR) .depend

=== src/ocamlbuild/Makefile ===
include Makefile.filelist

OCAMLBUILD := ocamlbuild -use-ocamlfind

all: byte opt

byte:
	$(OCAMLBUILD) $(BYTE_TARGETS)

opt: byte
	$(OCAMLBUILD) $(OPT_TARGETS)

clean:
	$(OCAMLBUILD) -clean

distclean: clean

odoc:
	$(OCAMLBUILD) $(DOC)

install_dir:
	$(INSTALL) -m 755 -d $(OCAMLBUILDDIR)
	$(INSTALL) -m 644 $(addprefix _build/,$(INTF)) $(OCAMLBUILDDIR)

install.opt: install_dir
	$(INSTALL) -m 644 $(addprefix _build/,$(OPT_TARGETS)) $(OCAMLBUILDDIR)

install.byte: install_dir
	$(INSTALL) -m 644 $(addprefix _build/,$(BYTE_TARGETS)) $(OCAMLBUILDDIR)

install: install.opt install.byte

uninstall:
	-rm -fr $(OCAMLBUILDDIR)

=== src/server/Makefile ===
include ../../Makefile.config
include Makefile.filelist
include ../clientserver/Makefile.filelist
include ../server2/Makefile.filelist

LIBS     := -I private ${addprefix -package ,${SERVER_PACKAGE} ${EXTRA_SYNTAXES} deriving.syntax.std} \
	    -ppopt ../syntax/pa_include.cmo
OCAMLC   := $(OCAMLFIND) ocamlc${BYTEDBG} ${THREAD}
OCAMLOPT := $(OCAMLFIND) ocamlopt ${OPTDBG} ${THREAD}
OCAMLDEP := $(OCAMLFIND) ocamldep

OCAMLDOC := ${OCAMLFIND} ocamldoc ${THREAD} -ppopt o -ppopt -printer
## WTF -ppopt options must be given in reverse order...

INCLUDEDOC := -I ../server2 -I ../server2/extensions -I ../clientserver/_server -I . -I ../common -I ../common2

all: byte opt

### Common files ###

COMMON_FILES  := $(notdir $(wildcard ../common/*.mli) $(wildcard ../common/*.ml))
COMMON_PFILES := $(addprefix private/, \
		     $(notdir $(wildcard ../common/private/*.mli) \
	                      $(wildcard ../common/private/*.ml)))
COMMON_SFILES := $(addprefix sigs/, \
		     $(notdir $(wildcard ../common/sigs/*.mli) \
	                      $(wildcard ../common/sigs/*.ml)))

PREDEP := ${COMMON_FILES} ${COMMON_PFILES} ${COMMON_SFILES}

.SECONDARY: ${PREDEP}
${COMMON_FILES}: %: ../common/%
	-@mkdir -p $(dir $@)
	ln -sf $< $@
${COMMON_PFILES} ${COMMON_SFILES}: %: ../common/%
	-@mkdir -p $(dir $@)
	ln -sf ../$< $@

FILES := ${SFILES}

SINTF_NOP4 :=

byte:: ${FILES:.ml=.cmo}
opt:: ${FILES:.ml=.cmx}


##########

%.cmo: %.ml
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
%.cmx: %.ml
	$(OCAMLOPT) -syntax camlp4o ${LIBS} -c $<

%.cmi: %.mli
	$(OCAMLC) -syntax camlp4o ${LIBS} -c $<
${SINTF_NOP4:.mli=.cmi}: \
%.cmi: %.mli
	$(OCAMLC) ${LIBS} -c $<

%.odoc: %.mli
	${OCAMLDOC} -syntax camlp4o ${LIBS} ${INCLUDEDOC} -dump ${ODOC_DIR}$@ $<

../clientserver/_server/%.odoc: ../clientserver/%.server.mli
	-cp -f $< ${@:.odoc=.mli}
	-ln -s ../sigs ../clientserver/_server
	-ln -s ../server ../clientserver/server
	${OCAMLDOC} -syntax camlp4o ${LIBS} ${INCLUDEDOC} -dump ${ODOC_DIR}$@ ${@:.odoc=.mli}
	-rm -f ${@:.odoc=.mli}

${SINTF_NOP4:.mli=.odoc}: \
%.odoc: %.mli
	${OCAMLDOC} ${LIBS} -dump ${ODOC_DIR}$@ $<

%.cmxs: %.cmxa
	$(OCAMLOPT) -shared -linkall -o $@ $<

## INSTALL ##

odoc: ${SDOC:.mli=.odoc} \
      $(addprefix ../clientserver/,${SSDOC:.mli=.odoc}) \
      $(addprefix ../server2/,${SSSDOC:.mli=.odoc})

install: raw_install

install.byte: raw_install

install.opt: raw_install

raw_install: ${PREDEP}
	${INSTALL} -m 755 -d ${SERVERDIR}
	${INSTALL} -m 644 ${SINTF} ${INSTALL_IMPL} ${SINTF:.cmi=.mli} ${SERVERDIR}

uninstall:
	-rm -fr ${SERVERDIR}

## Clean up

clean:
	-rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot *.odoc
	-cd private && rm -f *.cm[ioax] *.cmxa *.cmxs *.o *.a *.annot *.odoc
distclean: clean
	-rm -f *~ \#* .\#* .depend
	-rm -f ${PREDEP}
	-rm -f .*.deps private/.*.deps

## Manual dependencies for pa_include.
eliom_registration_base.cmi eliom_registration_base.cmo eliom_registration_base.cmx \
eliom_registration.cmi eliom_registration.cmo eliom_registration.cmx eliom_registration.odoc \
eliom_mkforms.cmi eliom_mkforms.cmo eliom_mkforms.cmx eliom_mkforms.odoc \
eliom_mkreg.cmi eliom_mkreg.odoc: ${COMMON_SFILES} $(wildcard sigs/*.mli)

# Automatic dependencies

ifneq (${DEPEND},no)

## Ugly side effect to force ${PREDEP} creation before dependencies calculation
dummy_var := $(shell $(MAKE) DEPEND=no ${PREDEP} >/dev/null 2>&1)

DEPS := $(patsubst %,.%.deps,${COMMON_FILES}) \
	$(patsubst %,.%.deps,${COMMON_PFILES}) \
	$(patsubst %,.%.deps,$(wildcard *.mli *.ml)) \
	$(patsubst private/%,private/.%.deps,$(wildcard private/*.mli private/*.ml)) \

.SECONDARY: ${DEPS}
.depend: ${DEPS}
	cat $(shell ls .*.deps private/.*.deps) > .depend

.%.ml.deps: %.ml
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@
.%.mli.deps: %.mli
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@

private/.%.ml.deps: private/%.ml
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@
private/.%.mli.deps: private/%.mli
	 ${OCAMLDEP} ${LIBS} -syntax camlp4o $< > $@

$(patsubst %.mli,.%.mli.deps,${SINTF_NOP4}): .%.mli.deps: %.mli
	 ${OCAMLDEP} ${LIBS} $< > $@

include .depend

endif

=== debian/changelog ===
eliom (4.0.0-2) unstable; urgency=medium

  * debian/patches:
    + Fix build on bytecode architectures

 -- Stéphane Glondu <glondu@debian.org>  Thu, 10 Jul 2014 09:39:42 +0200

eliom (4.0.0-1) unstable; urgency=medium

  * New upstream release
  * debian/patches:
    + Install .o files with .cmx files
  * Bump debhelper compat level to 9
  * Bump Standards-Version to 3.9.5
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Sun, 29 Jun 2014 13:57:29 +0200

eliom (3.0.3-5) unstable; urgency=medium

  * Team upload.
  * Fix ocamldoc invocation for doc/{server,client} (Closes: #746094).
    - Add 0001-Fix-ocamldoc-invocation-in-src-server-client.patch
  * Bump build-dependency on ocaml-find to 1.4.1, as a consequence of the patch
    introduced to fix the FTBFS issue.

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 10 May 2014 17:12:48 +0200

=== debian/control ===
Source: eliom
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
  Stéphane Glondu <glondu@debian.org>,
  Pierre Chambart <pierre.chambart@crans.org>
Build-Depends:
  debhelper (>= 9),
  dh-ocaml,
  libocsigenserver-ocaml-dev (>= 2.4),
  libderiving-ocsigen-ocaml-dev (>= 0.6),
  libjs-of-ocaml-dev (>= 2.2),
  libcalendar-ocaml-dev (>= 2.03.1),
  liblwt-ssl-ocaml-dev,
  libreact-ocaml-dev (>= 0.9.3),
  js-of-ocaml (>= 2.2),
  libtyxml-ocaml-dev (>= 3),
  liboptcomp-camlp4-dev,
  ocaml-findlib,
  ocaml-nox
Standards-Version: 3.9.5
Homepage: http://ocsigen.org/eliom
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/eliom.git
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/eliom.git

Package: eliom
Architecture: any
Depends:
 libeliom-ocaml-dev,
 ocaml-findlib,
 js-of-ocaml,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 libeliom-ocaml-doc
Replaces: libeliom-ocaml-dev (<< 3)
Breaks: libeliom-ocaml-dev (<< 3)
Description: web framework for ocsigenserver (tools)
 Eliom allows one to easily develop sophisticated client/server Web
 applications using OCaml.
 .
 This package contains command-line tools.

Package: libeliom-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends:
 ocaml-findlib
Description: web framework for ocsigenserver (dev libraries)
 Eliom allows one to easily develop sophisticated client/server Web
 applications using OCaml.
 .
 This package contains the development files needed to use Eliom.

Package: libeliom-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends:
 ocaml-findlib
Description: web framework for ocsigenserver (runtime libraries)
 Eliom allows one to easily develop sophisticated client/server Web
 applications using OCaml.
 .
 This package contains dynamically loadable modules to use with
 Ocsigenserver.

Package: libeliom-ocaml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Enhances: libeliom-ocaml-dev
Description: web framework for ocsigenserver (documentation)
 Eliom allows one to easily develop sophisticated client/server Web
 applications using OCaml.
 .
 This package contains documentation: the manual (in wikicreole
 format) and the API reference generated by ocamldoc (in HTML format).

=== debian/watch ===
version=3
http://ocsigen.org/eliom/install .*/archive/(.*)\.tar\.gz
